#ifndef __VRX_PPE_H_
#define __VRX_PPE_H_

//  wrapper got from chiptest for quick test
//  this file should be removed after code re-write

#define VRX_PPE_BASE                    (0xA0000000 | 0x1E200000)
#define VRX_PPE_0_CDM                   VRX_PPE_BASE + (0x1000 * 4)
#define VRX_PPE_1_CDM                   VRX_PPE_BASE + (0x11000 * 4)
#define VRX_PPE_REG_BASE                VRX_PPE_BASE + (0xD000 * 4)

#define VRX_CDM_CODE_MEMORY(i, x)       (VRX_PPE_BASE + (((x) + (((i)*0x10000)+0x001000)) << 2))
#define VRX_CDM_DATA_MEMORY(i, x)       (VRX_PPE_BASE + (((x) + (((i)*0x10000)+0x004000)) << 2))
#define VRX_SB_MEMORY(i)                (VRX_PPE_BASE + (((i) + 0x008000) << 2))

#define VRX_PPE0_CPU_CTRL_CMD			VRX_PPE_BASE + (0x0B00 * 4)
#define VRX_PPE0_CPU_CTRL_OPT			VRX_PPE_BASE + (0x0C00 * 4)
#define VRX_PPE0_BP_CTRL				VRX_PPE_BASE + (0x0900 * 4)
#define VRX_PPE0_BP_REASON				VRX_PPE_BASE + (0x0A00 * 4)
#define VRX_PPE0_BP_TRIGGER				VRX_PPE_BASE + (0x0F00 * 4)
#define VRX_PPE0_CPU_STATUS				VRX_PPE_BASE + (0x0D00 * 4)
#define VRX_PPE0_GPR					VRX_PPE_BASE + (0x0E00 * 4)

#define VRX_PPE_FREEZE                  VRX_PPE_REG_BASE + (0x0000 * 4) 
#define VRX_PPE_SRST                    VRX_PPE_REG_BASE + (0x0020 * 4)
#define VRX_PPE_PP32_0_CFG              VRX_PPE_REG_BASE + (0x0030 * 4)
#define VRX_PPE_PP32_1_CFG              VRX_PPE_REG_BASE + (0x0031 * 4) 
#define VRX_PPE_PP32_0_SLEEP            VRX_PPE_REG_BASE + (0x0038 * 4)
#define VRX_PPE_PP32_1_SLEEP            VRX_PPE_REG_BASE + (0x0039 * 4)
#define VRX_PPE_PWR_CTRL                VRX_PPE_REG_BASE + (0x003A * 4)
#define VRX_PPE_BRKSW_CFG               VRX_PPE_REG_BASE + (0x0040 * 4)

#define VRX_PPE_CDM_CFG                 VRX_PPE_REG_BASE + (0x0100 * 4)
#define VRX_PPE_MBOX_IGU0_ISRS          VRX_PPE_REG_BASE + (0x0200 * 4)
#define VRX_PPE_MBOX_IGU0_ISRC          VRX_PPE_REG_BASE + (0x0201 * 4)
#define VRX_PPE_MBOX_IGU0_ISR           VRX_PPE_REG_BASE + (0x0202 * 4)
#define VRX_PPE_MBOX_IGU0_IER           VRX_PPE_REG_BASE + (0x0203 * 4)
#define VRX_PPE_MBOX_IGU1_ISRS          VRX_PPE_REG_BASE + (0x0204 * 4)
#define VRX_PPE_MBOX_IGU1_ISRC          VRX_PPE_REG_BASE + (0x0205 * 4)
#define VRX_PPE_MBOX_IGU1_ISR           VRX_PPE_REG_BASE + (0x0206 * 4)
#define VRX_PPE_MBOX_IGU1_IER           VRX_PPE_REG_BASE + (0x0207 * 4)
#define VRX_PPE_MBOX_IGU2_ISRS          VRX_PPE_REG_BASE + (0x0210 * 4)
#define VRX_PPE_MBOX_IGU2_ISRC          VRX_PPE_REG_BASE + (0x0211 * 4)
#define VRX_PPE_MBOX_IGU2_ISR           VRX_PPE_REG_BASE + (0x0212 * 4)
#define VRX_PPE_MBOX_IGU2_IER           VRX_PPE_REG_BASE + (0x0213 * 4)
#define VRX_PPE_MBOX_IGU3_ISRS          VRX_PPE_REG_BASE + (0x0214 * 4)
#define VRX_PPE_MBOX_IGU3_ISRC          VRX_PPE_REG_BASE + (0x0215 * 4)
#define VRX_PPE_MBOX_IGU3_ISR           VRX_PPE_REG_BASE + (0x0216 * 4)
#define VRX_PPE_MBOX_IGU3_IER           VRX_PPE_REG_BASE + (0x0217 * 4)
#define VRX_PPE_MBOX_IGU4_ISRS          VRX_PPE_REG_BASE + (0x0218 * 4)
#define VRX_PPE_MBOX_IGU4_ISRC          VRX_PPE_REG_BASE + (0x0219 * 4)
#define VRX_PPE_MBOX_IGU4_ISR           VRX_PPE_REG_BASE + (0x021A * 4)
#define VRX_PPE_MBOX_IGU4_IER           VRX_PPE_REG_BASE + (0x021B * 4)
#define VRX_PPE_MBOX_IGU5_ISRS          VRX_PPE_REG_BASE + (0x021C * 4)
#define VRX_PPE_MBOX_IGU5_ISRC          VRX_PPE_REG_BASE + (0x021D * 4)
#define VRX_PPE_MBOX_IGU5_ISR           VRX_PPE_REG_BASE + (0x021E * 4)
#define VRX_PPE_MBOX_IGU5_IER           VRX_PPE_REG_BASE + (0x021F * 4)
#define VRX_PPE_MBOX_IGU6_ISRS          VRX_PPE_REG_BASE + (0x0220 * 4)
#define VRX_PPE_MBOX_IGU6_ISRC          VRX_PPE_REG_BASE + (0x0221 * 4)
#define VRX_PPE_MBOX_IGU6_ISR           VRX_PPE_REG_BASE + (0x0222 * 4)
#define VRX_PPE_MBOX_IGU6_IER           VRX_PPE_REG_BASE + (0x0223 * 4)
#define VRX_PPE_MBOX_BINSEM0            VRX_PPE_REG_BASE + (0x0230 * 4)
#define VRX_PPE_MBOX_BINSEM1            VRX_PPE_REG_BASE + (0x0231 * 4)
#define VRX_PPE_MBOX_BINSEM2            VRX_PPE_REG_BASE + (0x0232 * 4)
#define VRX_PPE_MBOX_BINSEM3            VRX_PPE_REG_BASE + (0x0233 * 4)

#define VRX_PPE_SB_MST_PRI0             VRX_PPE_REG_BASE + (0x0300 * 4)
#define VRX_PPE_SB_MST_PRI1             VRX_PPE_REG_BASE + (0x0301 * 4)
#define VRX_PPE_SB_MST_PRI2             VRX_PPE_REG_BASE + (0x0302 * 4)
#define VRX_PPE_SB_MST_PRI3             VRX_PPE_REG_BASE + (0x0303 * 4)
#define VRX_PPE_SB_MST_PRI4 		    VRX_PPE_REG_BASE + (0x0304 * 4)
#define VRX_PPE_SB_MST_PRI5 		    VRX_PPE_REG_BASE + (0x0305 * 4)
#define VRX_PPE_SB_MST_PRI6 		    VRX_PPE_REG_BASE + (0x0306 * 4)
#define VRX_PPE_SB_MST_SEL              VRX_PPE_REG_BASE + (0x0304 * 4)
#define VRX_PPE_RFBI_CFG                VRX_PPE_REG_BASE + (0x0400 * 4)
#define VRX_PPE_RBA_CFG0                VRX_PPE_REG_BASE + (0x0404 * 4)
#define VRX_PPE_RBA_CFG1                VRX_PPE_REG_BASE + (0x0405 * 4)
#define VRX_PPE_RCA_CFG0                VRX_PPE_REG_BASE + (0x0408 * 4)
#define VRX_PPE_RCA_CFG1                VRX_PPE_REG_BASE + (0x0409 * 4)
#define VRX_PPE_RDES_CFG0               VRX_PPE_REG_BASE + (0x040C * 4)
#define VRX_PPE_RDES_CFG1               VRX_PPE_REG_BASE + (0x040D * 4)

#define VRX_PPE_SFSM_STATE0             VRX_PPE_REG_BASE + (0x0410 * 4)
#define VRX_PPE_SFSM_STATE1             VRX_PPE_REG_BASE + (0x0411 * 4)
#define VRX_PPE_SFSM_DBA0               VRX_PPE_REG_BASE + (0x0412 * 4)
#define VRX_PPE_SFSM_DBA1               VRX_PPE_REG_BASE + (0x0413 * 4)
#define VRX_PPE_SFSM_CBA0               VRX_PPE_REG_BASE + (0x0414 * 4)
#define VRX_PPE_SFSM_CBA1               VRX_PPE_REG_BASE + (0x0415 * 4)
#define VRX_PPE_SFSM_CFG0               VRX_PPE_REG_BASE + (0x0416 * 4)
#define VRX_PPE_SFSM_CFG1               VRX_PPE_REG_BASE + (0x0417 * 4)
#define VRX_PPE_SFSM_PGCNT0             VRX_PPE_REG_BASE + (0x041C * 4)
#define VRX_PPE_SFSM_PGCNT1             VRX_PPE_REG_BASE + (0x041D * 4)
#define VRX_PPE_SFSM_PEND_PGCNT0 	    VRX_PPE_REG_BASE + (0x041E * 4)
#define VRX_PPE_SFSM_PEND_PGCNT1 	    VRX_PPE_REG_BASE + (0x041F * 4)

#define VRX_PPE_FFSM_DBA0               VRX_PPE_REG_BASE + (0x0508 * 4)
#define VRX_PPE_FFSM_DBA1               VRX_PPE_REG_BASE + (0x0509 * 4)
#define VRX_PPE_FFSM_CFG0               VRX_PPE_REG_BASE + (0x050A * 4)
#define VRX_PPE_FFSM_CFG1               VRX_PPE_REG_BASE + (0x050B * 4)
#define VRX_PPE_FFSM_IDLE_HEAD_BC0      VRX_PPE_REG_BASE + (0x050E * 4)
#define VRX_PPE_FFSM_IDLE_HEAD_BC1      VRX_PPE_REG_BASE + (0x050F * 4)
#define VRX_PPE_FFSM_PGCNT0             VRX_PPE_REG_BASE + (0x0514 * 4)
#define VRX_PPE_FFSM_PGCNT1             VRX_PPE_REG_BASE + (0x0515 * 4)

#define VRX_PPE_BMC_CFG0                VRX_PPE_REG_BASE + (0x0800 * 4)
#define VRX_PPE_BMC_POLY0               VRX_PPE_REG_BASE + (0x0801 * 4)
#define VRX_PPE_BMC_CRC0                VRX_PPE_REG_BASE + (0x0802 * 4)
#define VRX_PPE_BMC_CFG1                VRX_PPE_REG_BASE + (0x0803 * 4)
#define VRX_PPE_BMC_POLY1               VRX_PPE_REG_BASE + (0x0804 * 4)
#define VRX_PPE_BMC_CRC1                VRX_PPE_REG_BASE + (0x0805 * 4)
#define VRX_PPE_BMC_CMD3                VRX_PPE_REG_BASE + (0x0806 * 4)
#define VRX_PPE_BMC_CMD2                VRX_PPE_REG_BASE + (0x0807 * 4)
#define VRX_PPE_BMC_CMD1                VRX_PPE_REG_BASE + (0x0808 * 4)
#define VRX_PPE_BMC_CMD0                VRX_PPE_REG_BASE + (0x0809 * 4)
#define VRX_PPE_SAR_MODE_CFG 		    VRX_PPE_REG_BASE + (0x080A * 4)
#define VRX_PPE_SAR_RX_CMDCNT 		    VRX_PPE_REG_BASE + (0x080B * 4)
#define VRX_PPE_SAR_TX_CMDCNT 		    VRX_PPE_REG_BASE + (0x080C * 4)
#define VRX_PPE_SAR_RX_CTX_CFG 		    VRX_PPE_REG_BASE + (0x080D * 4)
#define VRX_PPE_SAR_TX_CTX_CFG 		    VRX_PPE_REG_BASE + (0x080E * 4)
#define VRX_PPE_SAR_TX_CMD_DONE_CNT     VRX_PPE_REG_BASE + (0x080F * 4)
#define VRX_PPE_SAR_ISR 			    VRX_PPE_REG_BASE + (0x0810 * 4)
#define VRX_PPE_SAR_IER 			    VRX_PPE_REG_BASE + (0x0811 * 4)
#define VRX_PPE_SAR_POLY_CFG_SET0  	    VRX_PPE_REG_BASE + (0x0812 * 4)
#define VRX_PPE_SAR_POLY_CFG_SET1 	    VRX_PPE_REG_BASE + (0x0813 * 4)
#define VRX_PPE_SAR_POLY_CFG_SET2 	    VRX_PPE_REG_BASE + (0x0814 * 4)
#define VRX_PPE_SAR_POLY_CFG_SET3 	    VRX_PPE_REG_BASE + (0x0815 * 4)
#define VRX_PPE_SAR_CRC_SIZE_CFG 	    VRX_PPE_REG_BASE + (0x0816 * 4)

#define VRX_PPE_SLL_CMD1                VRX_PPE_REG_BASE + (0x0900 * 4)
#define VRX_PPE_SLL_CMD0                VRX_PPE_REG_BASE + (0x0901 * 4)
#define VRX_PPE_SLL_KEY0                VRX_PPE_REG_BASE + (0x0910 * 4)
#define VRX_PPE_SLL_KEY1                VRX_PPE_REG_BASE + (0x0911 * 4)
#define VRX_PPE_SLL_KEY2                VRX_PPE_REG_BASE + (0x0912 * 4)
#define VRX_PPE_SLL_KEY3                VRX_PPE_REG_BASE + (0x0913 * 4)
#define VRX_PPE_SLL_KEY4                VRX_PPE_REG_BASE + (0x0914 * 4)
#define VRX_PPE_SLL_KEY5                VRX_PPE_REG_BASE + (0x0915 * 4)
#define VRX_PPE_SLL_RESULT              VRX_PPE_REG_BASE + (0x0920 * 4)

#define VRX_PPE_PDMA_CFG                VRX_PPE_REG_BASE + (0x0A00 * 4)
#define VRX_PPE_PDMA_RX_CMDCNT          VRX_PPE_REG_BASE + (0x0A01 * 4)
#define VRX_PPE_PDMA_TX_CMDCNT          VRX_PPE_REG_BASE + (0x0A02 * 4)
#define VRX_PPE_PDMA_RX_FWDATACNT       VRX_PPE_REG_BASE + (0x0A03 * 4)
#define VRX_PPE_PDMA_TX_FWDATACNT       VRX_PPE_REG_BASE + (0x0A04 * 4)
#define VRX_PPE_PDMA_RX_CTX_CFG         VRX_PPE_REG_BASE + (0x0A05 * 4)
#define VRX_PPE_PDMA_TX_CTX_CFG         VRX_PPE_REG_BASE + (0x0A06 * 4)
#define VRX_PPE_PDMA_RX_MAX_LEN_REG     VRX_PPE_REG_BASE + (0x0A07 * 4)
#define VRX_PPE_PDMA_RX_DELAY_CFG       VRX_PPE_REG_BASE + (0x0A08 * 4)
#define VRX_PPE_PDMA_INT_FIFO_RD        VRX_PPE_REG_BASE + (0x0A09 * 4)
#define VRX_PPE_PDMA_ISR                VRX_PPE_REG_BASE + (0x0A0A * 4)
#define VRX_PPE_PDMA_IER                VRX_PPE_REG_BASE + (0x0A0B * 4)
#define VRX_PPE_PDMA_SUBID              VRX_PPE_REG_BASE + (0x0A0C * 4)
#define VRX_PPE_PDMA_BAR0               VRX_PPE_REG_BASE + (0x0A0D * 4)
#define VRX_PPE_PDMA_BAR1               VRX_PPE_REG_BASE + (0x0A0E * 4)
#define VRX_PPE_EMA_CMDCFG              VRX_PPE_REG_BASE + (0x0F00 * 4)
#define VRX_PPE_EMA_DATACFG             VRX_PPE_REG_BASE + (0x0F02 * 4)
#define VRX_PPE_EMA_CMDCNT              VRX_PPE_REG_BASE + (0x0A02 * 4)
#define VRX_PPE_EMA_DATACNT             VRX_PPE_REG_BASE + (0x0A03 * 4)
#define VRX_PPE_EMA_ISR                 VRX_PPE_REG_BASE + (0x0A04 * 4)
#define VRX_PPE_EMA_IER                 VRX_PPE_REG_BASE + (0x0A05 * 4)
#define VRX_PPE_EMA_CFG                 VRX_PPE_REG_BASE + (0x0A06 * 4)
#define VRX_PPE_EMA_SUBID               VRX_PPE_REG_BASE + (0x0A07 * 4)

#define VRX_PPE_DREG_MISC_RAM0 		    VRX_PPE_REG_BASE + (0x0DC0 * 4)
#define VRX_PPE_DREG_MISC_RAM1 		    VRX_PPE_REG_BASE + (0x0DC1 * 4)
#define VRX_PPE_DREG_MISC_RAM2 		    VRX_PPE_REG_BASE + (0x0DC2 * 4)
#define VRX_PPE_DREG_MISC_RAM3 		    VRX_PPE_REG_BASE + (0x0DC3 * 4)
#define VRX_PPE_DREG_MISC_RAM4 		    VRX_PPE_REG_BASE + (0x0DC4 * 4)
#define VRX_PPE_DREG_MISC_RAM5		    VRX_PPE_REG_BASE + (0x0DC5 * 4)
#define VRX_PPE_DREG_MISC_RAM6 		    VRX_PPE_REG_BASE + (0x0DC6 * 4)
#define VRX_PPE_DREG_MISC_RAM7 		    VRX_PPE_REG_BASE + (0x0DC7 * 4)
#define VRX_PPE_DREG_MISC_RAM8 		    VRX_PPE_REG_BASE + (0x0DC8 * 4)
#define VRX_PPE_DREG_MISC_RAM9 		    VRX_PPE_REG_BASE + (0x0DC9 * 4)
#define VRX_PPE_DREG_MISC_RAM10 		VRX_PPE_REG_BASE + (0x0DCA * 4)
#define VRX_PPE_DREG_MISC_RAM11 		VRX_PPE_REG_BASE + (0x0DCB * 4)
#define VRX_PPE_DREG_MISC_RAM12 		VRX_PPE_REG_BASE + (0x0DCC * 4)
#define VRX_PPE_DREG_MISC_RAM13	 	    VRX_PPE_REG_BASE + (0x0DCD * 4)
#define VRX_PPE_DREG_MISC_RAM14 		VRX_PPE_REG_BASE + (0x0DCE * 4)
#define VRX_PPE_DREG_MISC_RAM15		    VRX_PPE_REG_BASE + (0x0DCF * 4)
#define VRX_PPE_DREG_MISC_RAM16 		VRX_PPE_REG_BASE + (0x0DD0 * 4)
#define VRX_PPE_DREG_MISC_RAM17 		VRX_PPE_REG_BASE + (0x0DD1 * 4)
#define VRX_PPE_DREG_MISC_RAM18 		VRX_PPE_REG_BASE + (0x0DD2 * 4)
#define VRX_PPE_DREG_MISC_RAM19 		VRX_PPE_REG_BASE + (0x0DD3 * 4)
#define VRX_PPE_DREG_MISC_RAM20 		VRX_PPE_REG_BASE + (0x0DD4 * 4)
#define VRX_PPE_DREG_MISC_RAM21 		VRX_PPE_REG_BASE + (0x0DD5 * 4)
#define VRX_PPE_DREG_MISC_RAM22 		VRX_PPE_REG_BASE + (0x0DD6 * 4)
#define VRX_PPE_DREG_MISC_RAM23 		VRX_PPE_REG_BASE + (0x0DD7 * 4)
#define VRX_PPE_DREG_MISC_RAM24 		VRX_PPE_REG_BASE + (0x0DD8 * 4)
#define VRX_PPE_DREG_MISC_RAM25 		VRX_PPE_REG_BASE + (0x0DD9 * 4)
#define VRX_PPE_DREG_MISC_RAM26 		VRX_PPE_REG_BASE + (0x0DDA * 4)
#define VRX_PPE_DREG_MISC_RAM27 		VRX_PPE_REG_BASE + (0x0DDB * 4)
#define VRX_PPE_DREG_MISC_RAM28 		VRX_PPE_REG_BASE + (0x0DDC * 4)
#define VRX_PPE_DREG_MISC_RAM29 		VRX_PPE_REG_BASE + (0x0DDD * 4)
#define VRX_PPE_DREG_MISC_RAM30		    VRX_PPE_REG_BASE + (0x0DDE * 4)
#define VRX_PPE_DREG_MISC_RAM31 		VRX_PPE_REG_BASE + (0x0DDF * 4)
#define VRX_PPE_DREG_MB0_P2D_ISRS 	    VRX_PPE_REG_BASE + (0x0DE0 * 4)
#define VRX_PPE_DREG_MB0_P2D_ISRC		VRX_PPE_REG_BASE + (0x0DE1 * 4)
#define VRX_PPE_DREG_MB0_P2D_ISR 		VRX_PPE_REG_BASE + (0x0DE2 * 4)
#define VRX_PPE_DREG_MB0_P2D_IER        VRX_PPE_REG_BASE + (0x0DE3 * 4)
#define VRX_PPE_DREG_MB1_P2D_ISRS 	    VRX_PPE_REG_BASE + (0x0DF0 * 4)
#define VRX_PPE_DREG_MB1_P2D_ISRC 	    VRX_PPE_REG_BASE + (0x0DF1 * 4)
#define VRX_PPE_DREG_MB1_P2D_ISR 		VRX_PPE_REG_BASE + (0x0DF2 * 4)
#define VRX_PPE_DREG_MB1_P2D_IER        VRX_PPE_REG_BASE + (0x0DF3 * 4)
#define VRX_PPE_DREG_MB2_D2P_ISRS 	    VRX_PPE_REG_BASE + (0x0DE4 * 4)
#define VRX_PPE_DREG_MB2_D2P_ISRC 	    VRX_PPE_REG_BASE + (0x0DE5 * 4)
#define VRX_PPE_DREG_MB2_D2P_ISR 		VRX_PPE_REG_BASE + (0x0DE6 * 4)
#define VRX_PPE_DREG_MB2_D2P_IER 		VRX_PPE_REG_BASE + (0x0DE7 * 4)
#define VRX_PPE_DREG_MB3_D2P_ISRS 	    VRX_PPE_REG_BASE + (0x0DF4 * 4)
#define VRX_PPE_DREG_MB3_D2P_ISRC	 	VRX_PPE_REG_BASE + (0x0DF5 * 4)
#define VRX_PPE_DREG_MB3_D2P_ISR 		VRX_PPE_REG_BASE + (0x0DF6 * 4)
#define VRX_PPE_DREG_MB3_D2P_IER 		VRX_PPE_REG_BASE + (0x0DF7 * 4)
#define VRX_PPE_SAR_PDMA_RX_CMDBUF_CFG  VRX_PPE_REG_BASE + (0x0F00 * 4)
#define VRX_PPE_SAR_PDMA_TX_CMDBUF_CFG  VRX_PPE_REG_BASE + (0x0F01 * 4)
#define VRX_PPE_SAR_PDMA_RX_FW_CMDBUF_CFG   VRX_PPE_REG_BASE + (0x0F02 * 4)
#define VRX_PPE_SAR_PDMA_TX_FW_CMDBUF_CFG   VRX_PPE_REG_BASE + (0x0F03 * 4)
#define VRX_PPE_SAR_PDMA_RX_CMDBUF_STATUS   VRX_PPE_REG_BASE + (0x0F04 * 4)
#define VRX_PPE_SAR_PDMA_TX_CMDBUF_STATUS   VRX_PPE_REG_BASE + (0x0F05 * 4)

#define VRX_PPE_QSB_RELOG               VRX_PPE_REG_BASE + (0x0C00 * 4)
#define VRX_PPE_QSB_EMIT0               VRX_PPE_REG_BASE + (0x0C01 * 4)
#define VRX_PPE_QSB_EMIT1               VRX_PPE_REG_BASE + (0x0C02 * 4)
#define VRX_PPE_DREG_A_VERSION          VRX_PPE_REG_BASE + (0x0D00 * 4)
#define VRX_PPE_DREG_A_CFG              VRX_PPE_REG_BASE + (0x0D01 * 4)
#define VRX_PPE_DREG_AT_CTRL            VRX_PPE_REG_BASE + (0x0D02 * 4)
#define VRX_PPE_DREG_AT_CB_CFG0         VRX_PPE_REG_BASE + (0x0D03 * 4)
#define VRX_PPE_DREG_AT_CB_CFG1         VRX_PPE_REG_BASE + (0x0D04 * 4)
#define VRX_PPE_DREG_AR_CTRL            VRX_PPE_REG_BASE + (0x0D08 * 4)
#define VRX_PPE_DREG_AR_CB_CFG0         VRX_PPE_REG_BASE + (0x0D09 * 4)
#define VRX_PPE_DREG_AR_CB_CFG1         VRX_PPE_REG_BASE + (0x0D0A * 4)
#define VRX_PPE_DREG_A_UTPCFG           VRX_PPE_REG_BASE + (0x0D0E * 4)
#define VRX_PPE_DREG_A_STATUS           VRX_PPE_REG_BASE + (0x0D0F * 4)
#define VRX_PPE_DREG_AT_CFG0            VRX_PPE_REG_BASE + (0x0D20 * 4)
#define VRX_PPE_DREG_AT_CFG1            VRX_PPE_REG_BASE + (0x0D21 * 4)
#define VRX_PPE_DREG_AT_FB_SIZE0        VRX_PPE_REG_BASE + (0x0D22 * 4)
#define VRX_PPE_DREG_AT_FB_SIZE1        VRX_PPE_REG_BASE + (0x0D23 * 4)
#define VRX_PPE_DREG_AT_CELL0           VRX_PPE_REG_BASE + (0x0D24 * 4)
#define VRX_PPE_DREG_AT_CELL1           VRX_PPE_REG_BASE + (0x0D25 * 4)
#define VRX_PPE_DREG_AT_IDLE_CNT0       VRX_PPE_REG_BASE + (0x0D26 * 4)
#define VRX_PPE_DREG_AT_IDLE_CNT1       VRX_PPE_REG_BASE + (0x0D27 * 4)
#define VRX_PPE_DREG_AT_IDLE0           VRX_PPE_REG_BASE + (0x0D28 * 4)
#define VRX_PPE_DREG_AT_IDLE1           VRX_PPE_REG_BASE + (0x0D29 * 4)
#define VRX_PPE_DREG_AR_CFG0            VRX_PPE_REG_BASE + (0x0D60 * 4)
#define VRX_PPE_DREG_AR_CFG1            VRX_PPE_REG_BASE + (0x0D61 * 4)
#define VRX_PPE_DREG_AR_STAT0          	VRX_PPE_REG_BASE + (0x0D66 * 4)
#define VRX_PPE_DREG_AR_STAT1          	VRX_PPE_REG_BASE + (0x0D67 * 4)
#define VRX_PPE_DREG_AR_CELL0           VRX_PPE_REG_BASE + (0x0D68 * 4)
#define VRX_PPE_DREG_AR_CELL1           VRX_PPE_REG_BASE + (0x0D69 * 4)
#define VRX_PPE_DREG_AR_IDLE_CNT0       VRX_PPE_REG_BASE + (0x0D6A * 4)
#define VRX_PPE_DREG_AR_IDLE_CNT1       VRX_PPE_REG_BASE + (0x0D6B * 4)
#define VRX_PPE_DREG_AR_AIIDLE_CNT0     VRX_PPE_REG_BASE + (0x0D6C * 4)
#define VRX_PPE_DREG_AR_AIIDLE_CNT1     VRX_PPE_REG_BASE + (0x0D6D * 4)
#define VRX_PPE_DREG_AR_BE_CNT0         VRX_PPE_REG_BASE + (0x0D6E * 4)
#define VRX_PPE_DREG_AR_BE_CNT1         VRX_PPE_REG_BASE + (0x0D6F * 4)
#define VRX_PPE_DREG_AR_HEC_CNT0        VRX_PPE_REG_BASE + (0x0D70 * 4)
#define VRX_PPE_DREG_AR_HEC_CNT1        VRX_PPE_REG_BASE + (0x0D71 * 4)
#define VRX_PPE_DREG_AR_CD_CNT0         VRX_PPE_REG_BASE + (0x0D72 * 4)
#define VRX_PPE_DREG_AR_CD_CNT1         VRX_PPE_REG_BASE + (0x0D73 * 4)
#define VRX_PPE_DREG_AR_IDLE0           VRX_PPE_REG_BASE + (0x0D74 * 4)
#define VRX_PPE_DREG_AR_IDLE1           VRX_PPE_REG_BASE + (0x0D75 * 4)
#define VRX_PPE_DREG_AR_DELIN0          VRX_PPE_REG_BASE + (0x0D76 * 4)
#define VRX_PPE_DREG_AR_DELIN1          VRX_PPE_REG_BASE + (0x0D77 * 4)
#define VRX_PPE_DREG_RESV0              VRX_PPE_REG_BASE + (0x0D78 * 4)
#define VRX_PPE_DREG_RESV1              VRX_PPE_REG_BASE + (0x0D79 * 4)
#define VRX_PPE_DREG_RX_MIB_CMD0        VRX_PPE_REG_BASE + (0x0D80 * 4)
#define VRX_PPE_DREG_RX_MIB_CMD1        VRX_PPE_REG_BASE + (0x0D81 * 4)
#define VRX_PPE_DREG_AR_OVDROP_CNT0     VRX_PPE_REG_BASE + (0x0D98 * 4)
#define VRX_PPE_DREG_AR_OVDROP_CNT1     VRX_PPE_REG_BASE + (0x0D99 * 4)
#define VRX_PPE_DREG_AR_CERRN_CNT0	    VRX_PPE_REG_BASE + (0x0DA0 * 4)
#define VRX_PPE_DREG_AR_CERRN_CNT1      VRX_PPE_REG_BASE + (0x0DA1 * 4)
#define VRX_PPE_DREG_AR_CERRNP_CNT0     VRX_PPE_REG_BASE + (0x0DA2 * 4)
#define VRX_PPE_DREG_AR_CERRNP_CNT1     VRX_PPE_REG_BASE + (0x0DA3 * 4)
#define VRX_PPE_DREG_AR_CVN_CNT0		VRX_PPE_REG_BASE + (0x0DA4 * 4)
#define VRX_PPE_DREG_AR_CVN_CNT1        VRX_PPE_REG_BASE + (0x0DA5 * 4)
#define VRX_PPE_DREG_AR_CVNP_CNT0		VRX_PPE_REG_BASE + (0x0DA6 * 4)
#define VRX_PPE_DREG_AR_CVNP_CNT1       VRX_PPE_REG_BASE + (0x0DA7 * 4)
#define VRX_PPE_DREG_B0_LADR 		    VRX_PPE_REG_BASE + (0x0DA8 * 4)
#define VRX_PPE_DREG_B1_LADR 		    VRX_PPE_REG_BASE + (0x0DA9 * 4)
#define VRX_PPE_TC_RX_MIB_CMD0 		    VRX_PPE_REG_BASE + (0x0DB0 * 4)
#define VRX_PPE_TC_RX_MIB_CMD1 		    VRX_PPE_REG_BASE + (0x0DB1 * 4)
#define VRX_PPE_TC_RX_EFM_MIB_CMD0 	    VRX_PPE_REG_BASE + (0x0DB2 * 4)
#define VRX_PPE_TC_RX_EFM_MIB_CMD1 	    VRX_PPE_REG_BASE + (0x0DB3 * 4)

#define VRX_PPE_QSB_ICDV_REG            VRX_PPE_REG_BASE + (0x1007 * 4)
#define VRX_PPE_QSB_SBL_REG             VRX_PPE_REG_BASE + (0x1009 * 4)
#define VRX_PPE_QSB_CFG_REG             VRX_PPE_REG_BASE + (0x100A * 4)
#define VRX_PPE_QSB_RTM_REG             VRX_PPE_REG_BASE + (0x100B * 4)
#define VRX_PPE_QSB_RTD_REG             VRX_PPE_REG_BASE + (0x100C * 4)
#define VRX_PPE_QSB_RAMAC_REG           VRX_PPE_REG_BASE + (0x100D * 4)
#define VRX_PPE_QSB_ISTAT_REG           VRX_PPE_REG_BASE + (0x100E * 4)
#define VRX_PPE_QSB_IMR_REG             VRX_PPE_REG_BASE + (0x100F * 4)
#define VRX_PPE_QSB_SCR_REG             VRX_PPE_REG_BASE + (0x1010 * 4)

#endif
